library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity Mux4x4_1x4_VHDL is
    Port ( A,B,C,D :         in  std_logic_vector(3 downto 0);
           Dp3,Dp2,Dp1,Dp0 : in  std_logic;
			  S1,S0 :           in  std_logic;
           Y :               out std_logic_vector(3 downto 0);
           Dp :              out std_logic);
end Mux4x4_1x4_VHDL;

-----------------------------------------------------------------
-- Flgende concurrent kode implementerer to multipleksere
-- en 4x4-bit (4 stk - 4-bits busser)
-- en 1x4-bit (4 stk - 1-bit)
-----------------------------------------------------------------
architecture Behavioral of Mux4x4_1x4_VHDL is
	Signal Sel:   std_logic_vector(1 downto 0); 
	Signal SelNr: integer range 0 to 3;
begin
	Sel   <= S1&S0;	            -- Sel(1:0) = S1&S0 (2-bit bus)
	SelNr	<= Conv_Integer( Sel);	-- Omst til integer.

	with SelNr select
   Y <= A when 0,		 				-- Y <= A nr SelNr = 0
	     B when 1,		 				-- Y <= B nr SelNr = 1
		  C when 2,		 				-- Y <= C nr SelNr = 2
		  D when 3;		 				-- Y <= D nr SelNr = 3

	Dp <= Dp0 when Sel="00" else	-- Dp <= Dp0 nr SelNr = 0 
	      Dp1 when Sel="01" else	-- Dp <= Dp1 nr SelNr = 1 
	      Dp2 when Sel="10" else	-- Dp <= Dp2 nr SelNr = 2 
			Dp3;				 			-- Dp <= Dp3 (om ikke andet)

end Behavioral;
